//This file is "denergy.cc"
//Func. definition of member func. of the Lattice class.
//By Teck Leong Tan

#include "lattice.h"

//This function calculates the change in energy due to trial move
double Lattice::denergy(int ijk, int ll, int noccu_new)
{
   /* This func. calculates energy change of system due to change in 
      occupancy at site ijkl from noccu to noccu_new. Calculation is 
      done in the following manner:
      1. Loop over cluster (n,f,d)
      2. Get energy difference for each n,f,d.
      3. dE= sum of all energy differences over n,f,d
   */   
   double Probability=0;
   int random;
   //double dou_random;
   int noccu;
   double dE=0;
   noccu=noccupancy[ijk].site[ll].atomtype;
   //E_struct.dE=0; //dE is change in energy of system by an attempt. 
   
   //Loop over nbody
   for (int n=1;n<maxbody+1;n++)
   {
     //Loop over cluster types
     for (int f=0;f<clustree.sublat[ll].nbody[n].nclus.size();f++)
     {
       //cout<<"n= "<<n<<" f= "<<f<<" has ";
       //cout<<clustree.sublat[ll].nbody[n].nclus[f]->nsym.size()<<" degenarcies"<<endl;
       //cout<<"2*ndim= "<<2*ndim<<endl;
       
       //Loop over degeneracy
       for(int d=0;d<clustree.sublat[ll].nbody[n].nclus[f]->nsym.size();d++)
       {
         int c_ijkl [n][2];//Stores the ijk l of atoms in the cluster
         int c_occu [n];//Stores the atomtypes of the cluster
	       c_occu[0]=noccu;
	       int c_occu_new [n];//Stores the atomtypes of trial cluster
	       c_occu_new[0]=noccu_new;
	       int product=noccu;//Product of all elements in c_occu
	       int product_new=noccu_new;//Product of all elements in c_occu_new
	       double V_old=0;//Vin of present cluster
	       double V_new=0;//Vin of trial cluster
	 
	       //Loop over neighbor references
         for (int r=1;r<n;r++)
         {
           int temp;
           temp=clustree.sublat[ll].nbody[n].nclus[f]->nsym[d]->ref[r];
           c_ijkl[r][0]=noccupancy[ijk].site[ll].neighbors[temp]->ijk;
           c_ijkl[r][1]=noccupancy[ijk].site[ll].neighbors[temp]->l;

           c_occu[r]=noccupancy[c_ijkl[r][0]].site[c_ijkl[r][1]].atomtype;
           c_occu_new[r]=noccupancy[c_ijkl[r][0]].site[c_ijkl[r][1]].atomtype;
           product *=c_occu[r];
           product_new *=c_occu_new[r];
         }//end for (int r=0;r<n;r++)  


         if (0!=product)//if cluster does not contain vacancy
	       {
	         V_old=get_Vin(ll, n, f, c_occu);//get Vin of cluster
	         //cout<<"denergy line 59"<<endl;
	       }
	       if (0!=product_new)
	       {
	         V_new=get_Vin(ll, n, f, c_occu_new);
	         //cout<<"denergy line 65"<<endl;
	       }

	       dE+=(V_new-V_old);
	       //dE+=((product_new>0)*V_new-(product>0)*V_old);
       }//end for(int d=0;d<clustree.sublat[ll].nbody[n].nclus[f]...)
     }//end (int f=0;f<clustree.sublat[ll].nbody[n].nclus.size();f++
   }//end for (int n=1;n<maxbody;n++)
   return dE;
}       

//EOF
