/* This file is keywords.h
   It contains the keywords (flags) in the inputfile
   regonised by the programme.
   By Teck Leong Tan
*/

#ifndef _KEYWORDS_H
#define _KEYWORDS_H

static const int nkeys=22;
static const char* key_array[nkeys]={"NDIM","NTYPE","NBASIS", "RUNTYPE",\
                                     "RUNSTART", "CONFIGFILE", "CELLSIZE","MAXBODY",\
                                     "RSEED", "NPASS", "NEQUIL", "TEMPERATURE",\
                                     "CHEMPOT", "SROPAIR", "LRO","PHASE", \
                                     "SINV", "ELEMIND", "SINVDIR", "TOLLM", \
				     "OUTLEV", "STRUCTDIR"};
				    

/* Note: Certain keywords are compulsory. 
         'C' indicates compulsory keywords. Results in errors if not defined
         'I' indicates important but optional keywords
         'O' indicates optional keywords
         'd' means default


key_array[0]="NDIM";//No. of dimensions. 'C'
key_array[1]="NTYPE";//No. of independent atomic types. E.g in binary system
                     //NTYPE=1. For N-nary system, NTYPE=N-1; 'C'
key_array[2]="NBASIS";//No. of sublattices (basis) per cell; 'C'
key_array[3]="RUNTYPE";//Type of MC run. grand canonical or canonical; 
                       //'I', 'd'=g (grand canonical)
key_array[4]="RUNSTART"; Initial configuration for run
                          0: Create randomly 
                          1: From file, specify filename
                          2: Specified concentration
                          'O', 'd'=0              
/*key_array[5]="CONFIGFILE";//Input file for configuration; 'O'
key_array[6]="CELLSIZE";//No. of cells along each dimension; 'C'
key_array[7]="MAXBODY";//Maximum no. of interacting bodies; 'C'
key_array[8]="RSEED";//Seed for random no. generator; 'O' 
key_array[9]="NPASS";//No. of passes for sampling; 'I', 'd'=1
key_array[10]="NEQUIL";//No. of equilibration passes before sampling; 'I','d'=0
key_array[11]="TEMPERATURE";//Temperature steps, initial, final, increment. 'I'
key_array[12]="CHEMPOT";  Chemical potential steps for each independent 
                          species. Initial, final, increment; 'I' 
key_array[13]="SROPAIR";  Short range order pair correlation. Available options:
                           1.cut off  
                           2.all pairs 
                           'O' 
key_array[14]="LRO"; //Long range order parameter. 'O'
key_array[15]="PHASE"; //Turns on the phase diagram mode. 
                         Cooling and heating are both performed 'O'
key_array[16]="SINV";//Perform structural inversion 'I'
key_array[17]="ELEMIND";//User specify the index associated with element 'O'
key_array[18]="SINVDIR";//Directory of the inlatvec, inclus, inneighbor files  
                        //used in structural inversion 'O'
key_array[19]="TOLLM";//Tolerance used during lattice matching in struct inv. 
                      //Tolerance is given by the fraction of nearest 
		      //neighbor distance. 'O'
key_array[20]="OUTLEV"; //Level of output (low or high).The lower the level, the less output.
                          The minimum output will include E and Cv  'O'
key_array[21]="STRUCTDIR"; //Directory where structure dir and files are stored                          
		      
*/

#endif
//EOF//
