//This file is prep_vin.cc
//Definition of func. of Lattice class.
//The function initialises the interaction potentials and returns
//the no. of independent interactions
//By Teck Leong Tan

#include "lattice.h"

int Lattice::prep_Vin(Inversion& Inv)
{ 
   cout<<"In prep_vin.cc: "<<endl;
   int vcounter=0;//Keeps track of the indices of interaction potentials
   Inv.n_index.clear(); Inv.f_index.clear();//n,f indices for each elem. of J
   Inv.type_index.clear(); 
   //Assign indices for zero-body index
   Inv.n_index.push_back(0);
   Inv.f_index.push_back(0);
   Inv.type_index.push_back(0);
   //Assign index to zero body (constant) term 
   /*clustree.sublat[0].nbody[0].nclus[0]->Vin.assign(1,0);
   clustree.sublat[0].nbody[0].nclus[0]->Vin_hash.assign(1,0);
   clustree.sublat[0].nbody[0].flimit=0;*/
   //Constant term given an index of 0;
   vcounter++;	
   
   //Assign index to the other cluster interactions
   for (int ss=0;ss<num_sublat;ss++)
   {
     for (int n=0;n<clustree.sublat[ss].nbody.size() ;n++)
     {
       clustree.sublat[ss].nbody[n].flimit=clustree.sublat[ss].nbody[n].nclus.size()-1; 
       //Loop over cluster types
       for (int f=0;f<clustree.sublat[ss].nbody[n].nclus.size();f++)
       {
         //No. of interactions, Vin, for each cluster is num_type^(nbody)
         clustree.sublat[ss].nbody[n].nclus[f]->Vin.assign((power(num_type,n)),0);
       } 	 
       if (ss==0)//If sublat. index is zero
       {
         //The following determines the correct J-index to hash to during struct. inv.
         for (int f=0;f<clustree.sublat[0].nbody[n].all_clus.size();f++)
	 {
	   //....all_clus[f][g] contains the correct
	   clustree.sublat[0].nbody[n].all_clus[f].assign((power(num_type,n)),-1);
	   //Initialise 
	   vector<int>tensor; tensor.assign(n,1);
	   //vector<int>factor; factor.assign(n,1);
	   int linear_lowest;
	   //make_factor();//Initialise factor
	   //cout<<"line 25"<<endl;
	   for (int aa=0; aa<power(num_type,n);aa++)
	   {
	     //Find lowest tensor index
	     tensor_index(n, aa, tensor); //variable tensor will be obtained
	     //cout<<"tensor: "<<endl;
	     //for(int i=0;i<tensor.size();i++){cout<<tensor[i]<<" ";}
	     //cout<<endl;
	     sort(tensor.begin(),tensor.end());//sort to yield the smallest tensor index
	     //cout<<"after sort: "<<endl;
	     //for(int i=0;i<tensor.size();i++){cout<<tensor[i]<<" ";}
	     //cout<<endl;
	     for(int i=0;i<tensor.size();i++){tensor[i]+=1;}//prepare the tensor in the correct form.
	     linear_lowest=linear_index(n,tensor);//convert from tensor index to integer index
	     //cout<<"linear_lowest= "<<linear_lowest<<endl;
	     //Associate the correct index to Vin for sturctural inversion. 
	     //The index is stored in all_clus
	     if( clustree.sublat[0].nbody[n].all_clus[f][linear_lowest]==-1)
	     {
	       clustree.sublat[0].nbody[n].all_clus[f][aa]=vcounter;
               Inv.n_index.push_back(n);
               Inv.f_index.push_back(f);
               Inv.type_index.push_back(aa);
	       vcounter++;
	     }
	     else
	     {
	       clustree.sublat[0].nbody[n].all_clus[f][aa]=\
	       clustree.sublat[0].nbody[n].all_clus[f][linear_lowest];
	     }
	   }//end for (int aa=0; aa<power(num_type,n);aa++)
	 }//end for (int f=0;f<clustree.sublat[0].nbody[n].all_clus.size();f++)  
       }//end if(ss==0)
     }
   }//end for (int ss=0;ss<num_sublat;n++)
   //cout<<"vcounter= "<<vcounter<<endl;;
   return vcounter;//vcounter+1 will be the no. of independent interactions.
}
//EOF

/*void make_factor(vector<int> &factor, int n)
{
  //Loop over n bodies backwards
  for (int j=0;j<=n-1;j++ )
  { 
    factor[j]*=power(num_type,(n-1-j));//Initialise factor
  }//end for (int j=n-1;j>=0;j-- )
}

void make_tensor(vector<int> &tensor, vector<int> &factor, const int v)
{
  int linear=v;
  //Loop over no. of bodies
  for (int j=0;j<=factor.size()-1;j++ )
  {
    //Change from linear index to tensor index by successive division
    tensor[j]=linear/factor[j];
    linear=linear%factor[j];
  }
  //return linear;
}

int linearise (const vector<int> &tensor, const vector<int> &factor)
{
  int v=0; 
  for (int j=0; j<factor.size();j++)
  {
    v+=(tensor[j]*factor[j]);
    //cout<< "after sorting:" <<V_tensor[i];
  }
  return v;
}*/

