//This file is "print_output.cc".
//Definition of a member function of class Lattice.
//By Teck Leong Tan

#include "lattice.h"

/*This memeber function prints to output.out the relevant data
  at each temperature and chem pot step*/

void Lattice::print_output(fstream& output, double T)
{
  output<<resetiosflags(ios::scientific)<<setprecision(8)<<setw(8)<<setiosflags(ios::left)<<T<<" ";
  output<<setiosflags(ios::scientific)<<setprecision(6)<<E_struct.eavg+E_struct.V0<<"  ";//Average energy per atom
  output<<setprecision(6)<<E_struct.e+E_struct.V0<<"  ";//Energy per atom at final config
  //output<<setprecision(6)<<(E_struct.E2avg-E_struct.Eavg*E_struct.Eavg)/(T*T*natoms)<<"  "; //Cv//old way

  E_struct.Cv=(E_struct.e2avg-E_struct.eavg*E_struct.eavg)/(T*T);
  output<<setprecision(6)<<E_struct.Cv<<"  "; //Cv

  //Loop over independent atomic species
  for (int i=1;i<=num_type;i++)
  {
    output<<setprecision(4)<<C_struct.conc_avg[i]<<" ";//Average concentration
  }

  //Loop over independent atomic species
  for (int i=0;i<num_type;i++)
  {
    output<<setprecision(3)<<clustree.sublat[0].nbody[1].nclus[0]->Vin[i]<<" ";//Chem pot
  }
  output<<endl; 
}

//EOF
